/*
Wiltered-OTP v1.01
Written By: Samuel Sparling (webmaster@wilter.com)


An implimentation of the One Time Pad algorithm. The only algorithm known
to be 100% uncrackable.

To compile on unix:
gcc otp.c -o otp


Copyright  1997 Samuel Sparling
All Rights Reserved.
*/


#include <stdio.h>


static int die(void);
static int OtpEncrypt(void);
static char *version = "Wiltered-OTP v1.01\nWritten By: Samuel Sparling\n";
char infile[256], outfile[256], keyfile[256];
int i, k, o;

FILE *ifp, *ofp, *kfp;

int die(void)
{

if(ifp != NULL) fclose(ifp);
if(ofp != NULL) fclose(ofp);
if(kfp != NULL) fclose(kfp);
printf("\n");
return(0);
}


int main(void)
{
printf("%s", version);

printf("Input File: ");
scanf("%s", infile);

printf("Output File: ");
scanf("%s", outfile);

printf("Key File: ");
scanf("%s", keyfile);



ifp = fopen(infile, "r");
	if(ifp == NULL){
	printf("\nUnable to open input file %s!", infile);
        die();
	return(0);
	}
ofp = fopen(outfile, "w");
	if(ofp == NULL){
	printf("\nUnable to open output file %s!", outfile);
        die();
	return(0);
	}
kfp = fopen(keyfile, "r");
	if(kfp == NULL){
	printf("\nUnable to open key file %s!", keyfile);
        die();
	return(0);
	}

OtpEncrypt();
return(0);
}

int OtpEncrypt(void)
{

while(i != EOF)
{
i = getc(ifp);
k = getc(kfp);

if(k == NULL)
{
printf("Key is not long enough!");
die();
return(0);
}

if(i != EOF)
{
o = i ^= k;
while(o < 0){ o += 256; }
while(o > 256){ o -= 256; }
fprintf(ofp, "%c", o);
}

}


printf("Done encrypting %s to %s", infile, outfile);
die();
return(0);

}